#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "mainstuff.h"

void debug(char *format, ...)
{
#ifdef DEBUG
   va_list ap;
   
   va_start(ap,format);
   vfprintf(stderr,format, ap);
   va_end(ap);
#endif
}

void ldebug(int level, char *format, ...)
{
   
#ifdef DEBUG
   va_list ap;
   
   if (DEBUGLEVEL < level)
     return;
   va_start(ap,format);
   vfprintf(stderr,format, ap);
   va_end(ap);
#endif
}

void setButtonFont(GtkWidget *widget, gchar *fontname)
{
   GtkStyle *style= gtk_style_copy(gtk_widget_get_style(widget));

   /* Create a new style and attach it to the buttons */

#ifdef HASNOFONTSTYLE
   ;
#else
   gdk_font_unref (style->font);
   style->font = gdk_font_load(fontname);
#endif
   gtk_widget_set_style (widget, style);
}

void setFont(GtkWidget *widget, gchar *fontname)
{
   GtkStyle *style= gtk_style_copy(gtk_widget_get_style(widget));

   /* Create a new style and attach it to the labels */

#ifdef HASNOFONTSTYLE
   ;
#else
   gdk_font_unref (style->font);
   style->font = gdk_font_load(fontname);
#endif
   
   gtk_widget_set_style (widget, style);
}

void setFgColor(GtkWidget *widget, double rgb[3])
{

   GtkStyle *style= gtk_style_copy(gtk_widget_get_style(widget));

   GdkColor *c = (GdkColor*) malloc(sizeof(GdkColor));
   c->red   = (int)(rgb[0]*65535);
   c->green = (int)(rgb[1]*65535);
   c->blue  = (int)(rgb[2]*65535);

   style->fg[GTK_STATE_NORMAL] = *c;
   
   gtk_widget_set_style (widget, style);
}

void myinit(GtkWidget *window1)
{
   /* To change the label fonts : */
   double color1[] =  {   0.8,0.2,0.3  };
   double color2[] =  {   0.1,0.2,0.8  };
   
   gchar *font1 = "-misc-fixed-bold-r-normal--18-120-100-100-c-90-iso8859-1";

   setButtonFont (lookup_widget(window1,"button1") , font1);

   setFont (lookup_widget(window1,"leftlabel") , font1);
   setFont (lookup_widget(window1,"rightlabel"), font1);
   
   setFgColor (lookup_widget(window1,"leftlabel") , color1);
   setFgColor (lookup_widget(window1,"rightlabel"), color2);
   
   // Show already a preview of the current picture filename : 
   on_updatepreview_clicked
     ((GtkEntry *) lookup_widget (window1,"updatepreview"), NULL);
}

