#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <time.h>

// #define DEBUG 
/* MACRO DEBUG is to make debugging easier, but note that it disables
 * the creation of output files for DEBUGLEVEL > 1, and then writes to
 * stdout instead !
 */
#define DEBUGLEVEL 2 /* only for ldebug calls */
  
#define BROWSER "firefox"
#define MKTHUMBSWIDTH  "djpeg -pnm -dct float %s | pnmscale -width  %d | cjpeg -dct float -quality 75 > %s\n"
#define MKTHUMBSHEIGHT "djpeg -pnm -dct float %s | pnmscale -height %d | cjpeg -dct float -quality 75 > %s\n"

typedef struct _params
{
   int nrperindex;
   int thumbwidth;
   int thumbheight;
   int startnr;
   int endnr;
   int phcount;
   
   int  blocksize;
   char *basename;
   int  nrofdigits;
   char *jpgextension;
   char *htmlbasename; /* store basename without trailing _ if it has one */
   char *fullsizedir;
   char *thumbnailsdir;
} Params;

extern GtkWidget *window1;

/* From htmlstuff.c : */
Params *getParams(GtkWidget *widget);
int   getIntValue(GtkWidget *widget, char *widgetname);
char* getStringValue(GtkWidget *widget, char *widgetname);
void  setIntValue(GtkWidget *widget, char *widgetname, int newvalue);
void  setStringValue(GtkWidget *widget, char *widgetname, char *newstring);
void  generateHtml(GtkButton *button, gpointer user_data);
void  viewHtml(GtkButton *button, gpointer user_data);

/* From dialogstuff.c : */
void defaultAction(GtkButton *button, gpointer user_data);
void createDialogbox(char *line1, gpointer cancelAction, gpointer okAction);

/* From thumbsstuff.c : */
void thumbnailsDialog(GtkButton *button, gpointer user_data);
void generateThumbnails(GtkButton *button, gpointer user_data);

/* From extrastuff.c : */
void debug(char *format, ...);
void ldebug(int level, char *format, ...);
void myinit(GtkWidget *window1);

/* From libgladestuff.c : */
void add_to_search_path (const gchar *dir);
GtkWidget *lookup_widget (GtkWidget *root, char *widgetname);
GtkWidget* create_window1 (void);
GtkWidget* create_window2 (void);
GtkWidget* create_window3 (void);
GtkWidget* create_dialog1 (void);

/* From filestuff.c : */
extern void newFileSelector(char *preset, char **result, gpointer ok_action,
   gpointer cancel_action, gpointer user_data);

