#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"

#include "mainstuff.h"

void generateThumbnails(GtkButton *button, gpointer user_data)
{
   int x;
   char name[256];
   char fname[1024];
   char tname[1024];
   char command[1024];
   char *mkthumbscmd;
   int  dim;
   struct stat buf;
   Params *params;
   
   params = getParams(window1);
   
   fprintf(stderr,"Creating directory %s ....\n",params->thumbnailsdir);
   mkdir(params->thumbnailsdir,
	 S_IRWXU | S_IRGRP | S_IXGRP | S_IROTH | S_IXOTH);
   
   if(params->thumbwidth != 0)
   {
      dim = params->thumbwidth;
      fprintf(stderr,"Now generating Thumbnails (width=%d)....\n",
	      dim);
      mkthumbscmd = MKTHUMBSWIDTH;
   }
   else
   {
      dim = params->thumbheight;
      fprintf(stderr,"Now generating Thumbnails (height=%d)....\n",
	      dim);
      mkthumbscmd = MKTHUMBSHEIGHT;
   }
   
   for(x = params->startnr ; x<= params->endnr; x++)
   {
      snprintf(name,  sizeof(name)  -1, "%s%0*d",params->basename,params->nrofdigits,x);
      snprintf(fname, sizeof(fname) -1, "%s/%s.%s",params->fullsizedir,name,
	       params->jpgextension);
      snprintf(tname, sizeof(tname) -1, "%s/%s-%d.%s",params->thumbnailsdir,
	       name,dim,params->jpgextension);
      
      if(stat(fname,&buf) == 0) // only if photo really exists
      {
	 if(stat(tname,&buf) != 0) // only if thumb not exists
	 {
	    fprintf(stderr," Writing thumbnail for %s ...\n",fname);
	   
	    snprintf(command,sizeof(command)-1,mkthumbscmd,
		     fname, dim, tname);
	    system(command); /* assumes djpeg, pnmscale and cjpeg installed ! */
	 }
	 else
	   fprintf(stderr," Thumbnail for %s exists, skipping ...\n",fname);
      }
   }
   defaultAction(button,user_data); /* remove the dialogbox */
   
   fprintf(stderr,"Thumbnails ready !\n");
}

void thumbnailsDialog(GtkButton *button, gpointer user_data)
{
   createDialogbox("Create thumbnails directory\n"
		   "and generate thumbnails ?",
		   NULL,generateThumbnails);
}

